<template>
  <frame :modal="modal" no-dimmer position="dynamic">
    <div class="py-2 whitespace-no-wrap">
      <div v-if="!task.workspace().execSync().isInbox">
        <div v-if="!task.isDeadlined">
          <div
            class="px-4 py-2 flex flex-row items-center hover:bg-gray-100 cursor-pointer select-none"
            @click="modals.show('deadline-picker', $event)"
          >
            <i class="hero flag solid mr-2 text-red-500"></i> Add Deadline
          </div>
        </div>
        <div
          v-if="!task.remindAt"
          class="px-4 py-2 flex flex-row items-center hover:bg-gray-100 cursor-pointer select-none"
          @click="modals.show('reminder-picker', $event)"
        >
          <i class="hero bell solid mr-2 text-blue-500"></i> Reminder
        </div>
        <div v-if="!task.remindAt || !task.deadlineAt" class="border-b pt-2 mb-2"></div>
      </div>
      <div
        class="px-4 py-2 flex flex-row items-center hover:bg-gray-100 cursor-pointer select-none"
        @click="modals.show('workspace-picker', $event)"
      >
        <i class="hero chevron-double-right outline mr-2 text-gray-500"></i> Move...
      </div>
      <div
        class="px-4 py-2 flex flex-row items-center hover:bg-gray-100 cursor-pointer select-none"
        @click="modals.show('delete-confirmator')"
      >
        <i class="hero trash outline mr-2 text-gray-500"></i> Delete
      </div>
    </div>

    <modal :is="modals.inlined('reminder-picker')" dimmed position="center">
      <date-time-picker
        :value="remindValue"
        @cancel="modals.hide('reminder-picker')"
        @input="
          task.$setAndSaveAttributes({ remindAt: $event });
          modals.hide('reminder-picker');
          modal.hide();
          Push.ensure();
        "
      />
    </modal>
    <!--
    <modal :is="modals.inlined('deadline-picker')">
      <date-time-picker
        :value="deadlineValue"
        @input="
          task.$setAndSaveAttributes({ deadlineAt: $event });
          modals.hide('deadline-picker');
          modal.hide();
        "
      />
    </modal> -->

    <modal :is="modals.get('workspace-picker')" :value="task.workspace().execSync()" @input="workspaceInput($event)" />
    <modal :is="modals.get('deadline-picker')" :task="task" />
    <modal :is="modals.get('delete-confirmator')" @confirm="remove()" title="Delete Task" color="red" action="Delete">
      Are you sure you want to remove this Task? This can <span class="font-bold">not</span> be undone!
    </modal>
  </frame>
</template>

<script lang="ts">
import Task from "@/models/Task";
import { useModals, isModal } from "@/use/modal";
import Confirmator from "../Confirmator.vue";
import WorkspacePicker from "@/components/Workspaces/Picker.vue";
import Workspace from "@/models/Workspace";
import TaskDeadlinedPickerVue from "./TaskDeadlinedPicker.vue";
import DateTimePicker from "../DateTimePicker.vue";
import { computed } from "@vue/runtime-core";
import { DateTime } from "luxon";
import { Push } from "@/assets/Push";

export default {
  components: { DateTimePicker },
  mixins: [isModal()],
  emits: ["deleted"],
  props: {
    task: {
      required: true,
      type: Task
    }
  },
  setup(props, context) {
    const modals = useModals({
      DeleteConfirmator: Confirmator,
      WorkspacePicker,
      DeadlinePicker: TaskDeadlinedPickerVue
    });
    return {
      modals,
      workspaceInput: (workspace: Workspace) =>
        props.task
          .workspace()
          .associate(workspace)
          .save() && (props as any).modal.hide(),
      remove: async () => {
        props.task.delete();
        context.emit("deleted");
      },
      remindValue: computed(() => props.task.remindAt || DateTime.now()),
      deadlineValue: computed(() => props.task.deadlineAt || DateTime.now()),
      Push
    };
  }
};
</script>
